
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <stdio.h>
#include <math.h>
#include "header.h"
#include "upcnpb.h"

void setup_upc(int *argc, char **argv[]) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
// set up UPC stuff
//---------------------------------------------------------------------

      int i, nc;


      total_nodes = MAXCELLS*MAXCELLS;
      node = MYTHREAD;
      no_nodes = THREADS;
      if (no_nodes != total_nodes) {
         if (node == 0)
            printf("Error: no_nodes not matched with compiled\n");
         upc_global_exit(1);
      }

//---------------------------------------------------------------------
//     allocate and set up shared-memory buffer
//---------------------------------------------------------------------
      u_buffer = (shared sh_buf_t *)upc_all_alloc(no_nodes, sizeof(sh_buf_t));

      buffoff[0] = BUF_SIZE;
      buffoff[1] = buffoff[0] + BUF_SIZZ;

#ifdef USE_BARRIER
      buff_id = 0;
      if (node == 0)
         printf(" Starting the BARRIER version\n");
#else
      buffoff[2] = buffoff[1] + BUF_SIZZ;
      sync_init();
#endif

      if (! convertdouble) {
         dp_type = 1;
      } else {
         dp_type = 0;
      }

//---------------------------------------------------------------------
//     compute square root; add small number to allow for roundoff
//---------------------------------------------------------------------
      nc = (int)(sqrt((double)(total_nodes) + 0.00001e0));

//---------------------------------------------------------------------
// We handle a non-square number of nodes by making the excess nodes
// inactive. However, we can never handle more cells than were compiled
// in. 
//---------------------------------------------------------------------

      if (nc > MAXCELLS) nc = MAXCELLS;
//      if (node >= nc*nc) {
//         active = 0;
//         color = 1;
//      } else {
         active = 1;
//         color = 0;
//      }
      
//---------------------------------------------------------------------
//     let node 0 be the root for the group (there is only one)
//---------------------------------------------------------------------
      root = 0;

      return;
}

