//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <math.h>
#include "applu.incl"
#include "upcnpb.h"

void error() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//
//   compute the solution error
//
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j, k, m;
      int iglob, jglob;
      double  tmp;
      double  u000ijk[5], dummy[5];
#define u000ijk(i) u000ijk[i-1]
#define dummy(i) dummy[i-1]


      for (m = 1; m <= 5; m++) {
         errnm(m) = 0.0e+00;
         dummy(m) = 0.0e+00;
      }

      for (k = 2; k <= nz-1; k++) {
         for (j = jst; j <= jend; j++) {
            jglob = jpt + j;
            for (i = ist; i <= iend; i++) {
               iglob = ipt + i;
               exact( iglob, jglob, k, u000ijk );
               for (m = 1; m <= 5; m++) {
                  tmp = ( u000ijk(m) - u(m,i,j,k) );
                  dummy(m) = dummy(m) + tmp * tmp;
               }
            }
         }
      }

//---------------------------------------------------------------------
//   compute the global sum of individual contributions to dot product.
//---------------------------------------------------------------------
      mupc_reduce_r8( dummy, errnm, 5,
                      SMP_OPR_SUM, -1 );

      for (m = 1; m <= 5; m++) {
         errnm(m) = sqrt ( errnm(m) / ( (nx0-2)*(ny0-2)*(nz0-2) ) );
      }


      return;
#undef u000ijk
#undef dummy
}
