
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"
#include "upcnpb.h"

void exchange_4(double g[],double h[],int ibeg,int ifin1,int jbeg,int jfin1) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   compute the right hand side based on exact solution
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define g(i,j) g[(i)+(ISIZ2+2)*(j)]
#define h(i,j) h[(i)+(ISIZ2+2)*(j)]

//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j;
      int ny2;

      int ptr;



      ny2 = ny + 2;

//---------------------------------------------------------------------
//   communicate in the east and west directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send west
//---------------------------------------------------------------------
      if (jbeg==1) {
        ptr = wptr(1);
        ll_buffer = (double *)&u_buffer(node,ptr);
        ptr = 0;
        for (i = 1; i <= nx; i++) {
          ll_buffer(ptr + i) = g(i,1);
          ll_buffer(ptr + i + nx) = h(i,1);
        }

      }

      upc_barrier;

//---------------------------------------------------------------------
//   receive from east
//---------------------------------------------------------------------
      if (jfin1==ny) {

        ptr = wptr(1);
        upc_memget(ul_buffer, &u_buffer(east,ptr),
                   sizeof(double)*2*nx);
        ptr = 0;
        for (i = 1; i <= nx; i++) {
          g(i,ny+1) = ul_buffer(ptr + i);
          h(i,ny+1) = ul_buffer(ptr + i + nx);
        }

      }

//---------------------------------------------------------------------
//   communicate in the south and north directions
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   send north
//---------------------------------------------------------------------
      if (ibeg==1) {
        ptr = wptr(2);
        ll_buffer = (double *)&u_buffer(node,ptr);
        ptr = 1;
        for (j = 0; j <= ny+1; j++) {
          ll_buffer(ptr + j) = g(1,j);
          ll_buffer(ptr + j + ny2) = h(1,j);
        }

      }

      upc_barrier;

//---------------------------------------------------------------------
//   receive from south
//---------------------------------------------------------------------
      if (ifin1==nx) {

        ptr = wptr(2);
        upc_memget(ul_buffer, &u_buffer(south,ptr),
                   sizeof(double)*2*ny2);
        ptr = 1;
        for (j = 0; j <= ny+1; j++) {
          g(nx+1,j) = ul_buffer(ptr + j);
          h(nx+1,j) = ul_buffer(ptr + j + ny2);
        }

      }


      return;
#undef g
#undef h
}
