
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <stdio.h>
#include "applu.incl"
#include "upcnpb.h"

#define BSIZE 132

void read_input() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------


      int IERROR, fstatus, nnodes;
      FILE *fp;
      char cbuf[BSIZE];


//---------------------------------------------------------------------
//    only root reads the input file
//    if input file does not exist, it uses defaults
//       ipr = 1 for detailed progress output
//       inorm = how often the norm is printed (once every inorm iterations)
//       itmax = number of pseudo time steps
//       dt = time step
//       omega 1 over-relaxation factor for SSOR
//       tolrsd = steady state residual tolerance levels
//       nx, ny, nz = number of grid points in x, y, z directions
//---------------------------------------------------------------------
      root = 0;
      if (id == root) {

         printf("\n\n NAS Parallel Benchmarks 3.3 -- LU Benchmark\n\n");

         fp = fopen ("inputlu.data", "r");
         if (fp != NULL) {

            printf(" Reading from input file inputlu.data\n");

            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%d %d", &ipr, &inorm);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%d", &itmax);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%lf", &dt);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%lf", &omega);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%lf %lf %lf %lf %lf", 
                   &tolrsd(1),&tolrsd(2),&tolrsd(3),&tolrsd(4),&tolrsd(5));
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            fgets(cbuf, BSIZE, fp);
            sscanf(cbuf, "%d %d %d", &nx0, &ny0, &nz0);
            fclose(fp);
         } else {
            ipr = ipr_default;
            inorm = inorm_default;
            itmax = itmax_default;
            dt = dt_default;
            omega = omega_default;
            tolrsd(1) = tolrsd1_def;
            tolrsd(2) = tolrsd2_def;
            tolrsd(3) = tolrsd3_def;
            tolrsd(4) = tolrsd4_def;
            tolrsd(5) = tolrsd5_def;
            nx0 = ISIZ01;
            ny0 = ISIZ02;
            nz0 = ISIZ03;
         }

//---------------------------------------------------------------------
//   check problem size
//---------------------------------------------------------------------
	 nnodes = no_nodes;
         if (nnodes != NNODES_COMPILED) {
            printf("  Warning: program is running on %d processors\n",
                   nnodes);
            printf("  but was compiled for %d\n", NNODES_COMPILED);
         }

         if ( ( nx0 < 4 ) ||
              ( ny0 < 4 ) ||
              ( nz0 < 4 ) ) {

            printf("  PROBLEM SIZE IS TOO SMALL - \n%s\n",
                   "  SET EACH OF NX, NY AND NZ AT LEAST EQUAL TO 5");
      	    upc_global_exit(1);

         }

         if ( ( nx0 > ISIZ01 ) ||
              ( ny0 > ISIZ02 ) ||
              ( nz0 > ISIZ03 ) ) {

            printf("  PROBLEM SIZE IS TOO LARGE - \n%s\n%s\n",
                   "  NX, NY AND NZ SHOULD BE LESS THAN OR EQUAL TO",
                   "  ISIZ01, ISIZ02 AND ISIZ03 RESPECTIVELY");
      	    upc_global_exit(1);

         }


         printf(" Size: %4dx%4dx%4d\n", nx0, ny0, nz0);
         printf(" Iterations: %4d\n", itmax);
         printf(" Number of processes: %5d\n\n", nnodes);
         

      }

      bcast_inputs();

      return;
}


