
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <stdio.h>
#include "applu.incl"
#include "upcnpb.h"

void subdomain() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int mm, ierror, errorcode;


//---------------------------------------------------------------------
//
//   set up the sub-domain sizes
//
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//   x dimension
//---------------------------------------------------------------------
      mm   = (nx0%xdim);
      if (row<=mm) {
        nx = nx0/xdim + 1;
        ipt = (row-1)*nx;
      } else {
        nx = nx0/xdim;
        ipt = (row-1)*nx + mm;
      }

//---------------------------------------------------------------------
//   y dimension
//---------------------------------------------------------------------
      mm   = (ny0%ydim);
      if (col<=mm) {
        ny = ny0/ydim + 1;
        jpt = (col-1)*ny;
      } else {
        ny = ny0/ydim;
        jpt = (col-1)*ny + mm;
      }

//---------------------------------------------------------------------
//   z dimension
//---------------------------------------------------------------------
      nz = nz0;

//---------------------------------------------------------------------
//   check the sub-domain size
//---------------------------------------------------------------------
      if ( ( nx < 4 ) ||
           ( ny < 4 ) ||
           ( nz < 4 ) ) {
         printf("%s\n%s\n%s\n%s %3d %3d %3d\n",
                "  SUBDOMAIN SIZE IS TOO SMALL -",
                "  ADJUST PROBLEM SIZE OR NUMBER OF PROCESSORS",
                "  SO THAT NX, NY AND NZ ARE GREATER THAN OR EQUAL",
                "  TO 4 THEY ARE CURRENTLY", nx, ny, nz);
         errorcode = 1;
         upc_global_exit( errorcode );
      }

      if ( ( nx > ISIZ1 ) ||
           ( ny > ISIZ2 ) ||
           ( nz > ISIZ3 ) ) {
         printf("%s\n%s\n%s\n%s\n%s %4d %4d %4d\n",
                "  SUBDOMAIN SIZE IS TOO LARGE -",
                "  ADJUST PROBLEM SIZE OR NUMBER OF PROCESSORS",
                "  SO THAT NX, NY AND NZ ARE LESS THAN OR EQUAL TO",
                "  ISIZ1, ISIZ2 AND ISIZ3 RESPECTIVELY.  THEY ARE",
                "  CURRENTLY", nx, ny, nz);
         errorcode = 1;
         upc_global_exit( errorcode );
      }


//---------------------------------------------------------------------
//   set up the start and end in i and j extents for all processors
//---------------------------------------------------------------------
      ist = 1;
      iend = nx;
      if (north==-1) ist = 2;
      if (south==-1) iend = nx - 1;

      jst = 1;
      jend = ny;
      if (west==-1) jst = 2;
      if (east==-1) jend = ny - 1;

      return;
}


