
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include <stdio.h>
#include <unistd.h>
#include "header.h"
#include "upcnpb.h"

static FILE *btio_fp;
static void acc_sub_norms(int idump_cur);

long int iseek;

void setup_btio(void) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

      int  m;

      if (node == root) {
         /* remove old file if exists */
         unlink(filenm);
      }
      upc_barrier;

      btio_fp = fopen (filenm, "wb");
      if (!btio_fp) {
         printf("Error opening output file\n");
         upc_global_exit(1);
      }

      for (m = 1; m <= 5; m++) {
         xce_sub(m) = 0.e0;
      }

      idump_sub = 0;

      return;
}


//---------------------------------------------------------------------
//---------------------------------------------------------------------

void output_timestep(void) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

      int jio, kio, cio;
      size_t count, nrtn;

      for (cio = 1; cio <= ncells; cio++) {
          for (kio = 0; kio <= cell_size(3,cio)-1; kio++) {
              for (jio = 0; jio <= cell_size(2,cio)-1; jio++) {
                  iseek=(cell_low(1,cio) +
                         PROBLEM_SIZE*((cell_low(2,cio)+jio) +
                         PROBLEM_SIZE*((cell_low(3,cio)+kio) +
                         PROBLEM_SIZE*idump_sub)))*40;

                  fseek(btio_fp, iseek, SEEK_SET);
                  count = 5*cell_size(1,cio);
                  nrtn = fwrite((void *)&u(1,0,jio,kio,cio),
                                sizeof(double), count, btio_fp);
                  if (nrtn != count) {
                      printf(" Error writing to file\n");
                      upc_global_exit(-1);
                  }
              }
          }
      }

      idump_sub = idump_sub + 1;
      if (rd_interval > 0) {
         if (idump_sub >= rd_interval) {

            acc_sub_norms(idump+1);

            idump_sub = 0;
         }
      }

      return;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------

static void acc_sub_norms(int idump_cur) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

      int jio, kio, cio, ii, m, ichunk;
      size_t count, nrtn;
      double xce_single[5];

      ichunk = idump_cur - idump_sub + 1;
      for (ii = 0; ii <= idump_sub-1; ii++) {
        for (cio = 1; cio <= ncells; cio++) {
          for (kio = 0; kio <= cell_size(3,cio)-1; kio++) {
              for (jio = 0; jio <= cell_size(2,cio)-1; jio++) {
                  iseek=(cell_low(1,cio) +
                         PROBLEM_SIZE*((cell_low(2,cio)+jio) +
                         PROBLEM_SIZE*((cell_low(3,cio)+kio) +
                         PROBLEM_SIZE*ii)))*40;


                  fseek(btio_fp, iseek, SEEK_SET);
                  count = 5*cell_size(1,cio);
                  nrtn = fread((void *)&u(1,0,jio,kio,cio),
                               sizeof(double), count, btio_fp);
                  if (nrtn != count) {
                      printf(" Error reading back file\n");
                      upc_global_exit(-1);
                  }
              }
          }
        }

        if (node == root) printf(" Reading data set %5d\n", ii+ichunk);

        error_norm(xce_single);
        for (m = 1; m <= 5; m++) {
           xce_sub(m) = xce_sub(m) + xce_single[m-1];
        }
      }

      return;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------

void btio_cleanup(void) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

      fclose(btio_fp);

      return;
}

//---------------------------------------------------------------------
//---------------------------------------------------------------------

void accumulate_norms(double xce_acc[]) {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

      int m;

      if (rd_interval <= 0) {

      btio_fp = fopen (filenm, "rb");
      if (!btio_fp) {
         printf("Error opening file for read\n");
         upc_global_exit(1);
      }

//     clear the last time step

      clear_timestep();

//     read back the time steps and accumulate norms

      acc_sub_norms(idump);

      fclose(btio_fp);
      }

      for (m = 1; m <= 5; m++) {
         xce_acc[m-1] = xce_sub(m) / (double)(idump);
      }

      return;
}
