//---------------------------------------------------------------------
//---------------------------------------------------------------------
extern void exchange_1(double g[],int k,int iex);

void buts( int ldmx, int ldmy, int ldmz,
                       int nx, int ny, int nz, int k,
                       double omega,
                       double v[], double tv[],
                       double d[], double udx[], double udy[], double udz[],
                       int ist, int iend, int jst, int jend,
                       int nx0, int ny0, int ipt, int jpt ) {

      timer_start(15);
//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//
//   compute the regular-sparse, block upper triangular solution:
//
//                     v <-- ( U-inv ) * v
//
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//  input parameters
//---------------------------------------------------------------------
#define v(i,j,k,m) v[(i-1)+(5)*((j+1)+(ldmx+4)*((k+1)+(ldmy+4)*(m-1)))]
#define tv(i,j,k) tv[(i-1)+(5)*((j-1)+(ldmx)*(k-1))]
#define d(i,j,k,m) d[(i-1)+(5)*((j-1)+(5)*((k-1)+(ldmx)*(m-1)))]
#define udx(i,j,k,m) udx[(i-1)+(5)*((j-1)+(5)*((k-1)+(ldmx)*(m-1)))]
#define udy(i,j,k,m) udy[(i-1)+(5)*((j-1)+(5)*((k-1)+(ldmx)*(m-1)))]
#define udz(i,j,k,m) udz[(i-1)+(5)*((j-1)+(5)*((k-1)+(ldmx)*(m-1)))]

//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j, m;
      int iex;
      double  tmp, tmp1;
      double  tmat[5*5];
#define tmat(i,j) tmat[(i-1)+(5)*(j-1)]


//---------------------------------------------------------------------
//   receive data from south and east
//---------------------------------------------------------------------
      iex = 1;
      exchange_1( v,k,iex );

      for (j = jend; j >= jst; j--) {
         for (i = iend; i >= ist; i--) {
            for (m = 1; m <= 5; m++) {
                  tv( m, i, j ) = 
            omega * (  udz( m, 1, i, j ) * v( 1, i, j, k+1 )
                     + udz( m, 2, i, j ) * v( 2, i, j, k+1 )
                     + udz( m, 3, i, j ) * v( 3, i, j, k+1 )
                     + udz( m, 4, i, j ) * v( 4, i, j, k+1 )
                     + udz( m, 5, i, j ) * v( 5, i, j, k+1 ) );
            }
         }
      }


      for (j = jend; j >= jst; j--) {
        for (i = iend; i >= ist; i--) {

            for (m = 1; m <= 5; m++) {
                  tv( m, i, j ) = tv( m, i, j )
       + omega * ( udy( m, 1, i, j ) * v( 1, i, j+1, k )
                 + udx( m, 1, i, j ) * v( 1, i+1, j, k )
                 + udy( m, 2, i, j ) * v( 2, i, j+1, k )
                 + udx( m, 2, i, j ) * v( 2, i+1, j, k )
                 + udy( m, 3, i, j ) * v( 3, i, j+1, k )
                 + udx( m, 3, i, j ) * v( 3, i+1, j, k )
                 + udy( m, 4, i, j ) * v( 4, i, j+1, k )
                 + udx( m, 4, i, j ) * v( 4, i+1, j, k )
                 + udy( m, 5, i, j ) * v( 5, i, j+1, k )
                 + udx( m, 5, i, j ) * v( 5, i+1, j, k ) );
            }

//---------------------------------------------------------------------
//   diagonal block inversion
//---------------------------------------------------------------------
            for (m = 1; m <= 5; m++) {
               tmat( m, 1 ) = d( m, 1, i, j );
               tmat( m, 2 ) = d( m, 2, i, j );
               tmat( m, 3 ) = d( m, 3, i, j );
               tmat( m, 4 ) = d( m, 4, i, j );
               tmat( m, 5 ) = d( m, 5, i, j );
            }

            tmp1 = 1.0e+00 / tmat( 1, 1 );
            tmp = tmp1 * tmat( 2, 1 );
            tmat( 2, 2 ) =  tmat( 2, 2 )
                 - tmp * tmat( 1, 2 );
            tmat( 2, 3 ) =  tmat( 2, 3 )
                 - tmp * tmat( 1, 3 );
            tmat( 2, 4 ) =  tmat( 2, 4 )
                 - tmp * tmat( 1, 4 );
            tmat( 2, 5 ) =  tmat( 2, 5 )
                 - tmp * tmat( 1, 5 );
            tv( 2, i, j ) = tv( 2, i, j )
              - tv( 1, i, j ) * tmp;

            tmp = tmp1 * tmat( 3, 1 );
            tmat( 3, 2 ) =  tmat( 3, 2 )
                 - tmp * tmat( 1, 2 );
            tmat( 3, 3 ) =  tmat( 3, 3 )
                 - tmp * tmat( 1, 3 );
            tmat( 3, 4 ) =  tmat( 3, 4 )
                 - tmp * tmat( 1, 4 );
            tmat( 3, 5 ) =  tmat( 3, 5 )
                 - tmp * tmat( 1, 5 );
            tv( 3, i, j ) = tv( 3, i, j )
              - tv( 1, i, j ) * tmp;

            tmp = tmp1 * tmat( 4, 1 );
            tmat( 4, 2 ) =  tmat( 4, 2 )
                 - tmp * tmat( 1, 2 );
            tmat( 4, 3 ) =  tmat( 4, 3 )
                 - tmp * tmat( 1, 3 );
            tmat( 4, 4 ) =  tmat( 4, 4 )
                 - tmp * tmat( 1, 4 );
            tmat( 4, 5 ) =  tmat( 4, 5 )
                 - tmp * tmat( 1, 5 );
            tv( 4, i, j ) = tv( 4, i, j )
              - tv( 1, i, j ) * tmp;

            tmp = tmp1 * tmat( 5, 1 );
            tmat( 5, 2 ) =  tmat( 5, 2 )
                 - tmp * tmat( 1, 2 );
            tmat( 5, 3 ) =  tmat( 5, 3 )
                 - tmp * tmat( 1, 3 );
            tmat( 5, 4 ) =  tmat( 5, 4 )
                 - tmp * tmat( 1, 4 );
            tmat( 5, 5 ) =  tmat( 5, 5 )
                 - tmp * tmat( 1, 5 );
            tv( 5, i, j ) = tv( 5, i, j )
              - tv( 1, i, j ) * tmp;



            tmp1 = 1.0e+00 / tmat( 2, 2 );
            tmp = tmp1 * tmat( 3, 2 );
            tmat( 3, 3 ) =  tmat( 3, 3 )
                 - tmp * tmat( 2, 3 );
            tmat( 3, 4 ) =  tmat( 3, 4 )
                 - tmp * tmat( 2, 4 );
            tmat( 3, 5 ) =  tmat( 3, 5 )
                 - tmp * tmat( 2, 5 );
            tv( 3, i, j ) = tv( 3, i, j )
              - tv( 2, i, j ) * tmp;

            tmp = tmp1 * tmat( 4, 2 );
            tmat( 4, 3 ) =  tmat( 4, 3 )
                 - tmp * tmat( 2, 3 );
            tmat( 4, 4 ) =  tmat( 4, 4 )
                 - tmp * tmat( 2, 4 );
            tmat( 4, 5 ) =  tmat( 4, 5 )
                 - tmp * tmat( 2, 5 );
            tv( 4, i, j ) = tv( 4, i, j )
              - tv( 2, i, j ) * tmp;

            tmp = tmp1 * tmat( 5, 2 );
            tmat( 5, 3 ) =  tmat( 5, 3 )
                 - tmp * tmat( 2, 3 );
            tmat( 5, 4 ) =  tmat( 5, 4 )
                 - tmp * tmat( 2, 4 );
            tmat( 5, 5 ) =  tmat( 5, 5 )
                 - tmp * tmat( 2, 5 );
            tv( 5, i, j ) = tv( 5, i, j )
              - tv( 2, i, j ) * tmp;



            tmp1 = 1.0e+00 / tmat( 3, 3 );
            tmp = tmp1 * tmat( 4, 3 );
            tmat( 4, 4 ) =  tmat( 4, 4 )
                 - tmp * tmat( 3, 4 );
            tmat( 4, 5 ) =  tmat( 4, 5 )
                 - tmp * tmat( 3, 5 );
            tv( 4, i, j ) = tv( 4, i, j )
              - tv( 3, i, j ) * tmp;

            tmp = tmp1 * tmat( 5, 3 );
            tmat( 5, 4 ) =  tmat( 5, 4 )
                 - tmp * tmat( 3, 4 );
            tmat( 5, 5 ) =  tmat( 5, 5 )
                 - tmp * tmat( 3, 5 );
            tv( 5, i, j ) = tv( 5, i, j )
              - tv( 3, i, j ) * tmp;



            tmp1 = 1.0e+00 / tmat( 4, 4 );
            tmp = tmp1 * tmat( 5, 4 );
            tmat( 5, 5 ) =  tmat( 5, 5 )
                 - tmp * tmat( 4, 5 );
            tv( 5, i, j ) = tv( 5, i, j )
              - tv( 4, i, j ) * tmp;

//---------------------------------------------------------------------
//   back substitution
//---------------------------------------------------------------------
            tv( 5, i, j ) = tv( 5, i, j )
                            / tmat( 5, 5 );

            tv( 4, i, j ) = tv( 4, i, j )
                 - tmat( 4, 5 ) * tv( 5, i, j );
            tv( 4, i, j ) = tv( 4, i, j )
                            / tmat( 4, 4 );

            tv( 3, i, j ) = tv( 3, i, j )
                 - tmat( 3, 4 ) * tv( 4, i, j )
                 - tmat( 3, 5 ) * tv( 5, i, j );
            tv( 3, i, j ) = tv( 3, i, j )
                            / tmat( 3, 3 );

            tv( 2, i, j ) = tv( 2, i, j )
                 - tmat( 2, 3 ) * tv( 3, i, j )
                 - tmat( 2, 4 ) * tv( 4, i, j )
                 - tmat( 2, 5 ) * tv( 5, i, j );
            tv( 2, i, j ) = tv( 2, i, j )
                            / tmat( 2, 2 );

            tv( 1, i, j ) = tv( 1, i, j )
                 - tmat( 1, 2 ) * tv( 2, i, j )
                 - tmat( 1, 3 ) * tv( 3, i, j )
                 - tmat( 1, 4 ) * tv( 4, i, j )
                 - tmat( 1, 5 ) * tv( 5, i, j );
            tv( 1, i, j ) = tv( 1, i, j )
                            / tmat( 1, 1 );

            v( 1, i, j, k ) = v( 1, i, j, k ) - tv( 1, i, j );
            v( 2, i, j, k ) = v( 2, i, j, k ) - tv( 2, i, j );
            v( 3, i, j, k ) = v( 3, i, j, k ) - tv( 3, i, j );
            v( 4, i, j, k ) = v( 4, i, j, k ) - tv( 4, i, j );
            v( 5, i, j, k ) = v( 5, i, j, k ) - tv( 5, i, j );


        }
      }

//---------------------------------------------------------------------
//   send data to north and west
//---------------------------------------------------------------------
      iex = 3;
      timer_stop(15);
      timer_start(16);
      exchange_1( v,k,iex );
      timer_stop(16);
 
      return;
#undef v
#undef tv
#undef d
#undef udx
#undef udy
#undef udz
#undef tmat
}
