
//---------------------------------------------------------------------
//---------------------------------------------------------------------
#include "applu.incl"

void setiv() {

//---------------------------------------------------------------------
//---------------------------------------------------------------------

//---------------------------------------------------------------------
//
//   set the initial values of independent variables based on tri-linear
//   interpolation of boundary values in the computational space.
//
//---------------------------------------------------------------------


//---------------------------------------------------------------------
//  local variables
//---------------------------------------------------------------------
      int i, j, k, m;
      int iglob, jglob;
      double  xi, eta, zeta;
      double  pxi, peta, pzeta;
      double  ue_1jk[5],ue_nx0jk[5],ue_i1k[5],
              ue_iny0k[5],ue_ij1[5],ue_ijnz[5];
#define ue_1jk(i) ue_1jk[i-1]
#define ue_nx0jk(i) ue_nx0jk[i-1]
#define ue_i1k(i) ue_i1k[i-1]
#define ue_iny0k(i) ue_iny0k[i-1]
#define ue_ij1(i) ue_ij1[i-1]
#define ue_ijnz(i) ue_ijnz[i-1]


      for (k = 2; k <= nz - 1; k++) {
         zeta = ( (double) (k-1) ) / (nz-1);
         for (j = 1; j <= ny; j++) {
          jglob = jpt + j;
          if (jglob!=1&&jglob!=ny0) {
            eta = ( (double) (jglob-1) ) / (ny0-1);
            for (i = 1; i <= nx; i++) {
              iglob = ipt + i;
              if (iglob!=1&&iglob!=nx0) {
               xi = ( (double) (iglob-1) ) / (nx0-1);
               exact (1,jglob,k,ue_1jk);
               exact (nx0,jglob,k,ue_nx0jk);
               exact (iglob,1,k,ue_i1k);
               exact (iglob,ny0,k,ue_iny0k);
               exact (iglob,jglob,1,ue_ij1);
               exact (iglob,jglob,nz,ue_ijnz);
               for (m = 1; m <= 5; m++) {
                  pxi =   ( 1.0e+00 - xi ) * ue_1jk(m)
                                    + xi   * ue_nx0jk(m);
                  peta =  ( 1.0e+00 - eta ) * ue_i1k(m)
                                    + eta   * ue_iny0k(m);
                  pzeta = ( 1.0e+00 - zeta ) * ue_ij1(m)
                                    + zeta   * ue_ijnz(m);

                  u( m, i, j, k ) = pxi + peta + pzeta
                       - pxi * peta - peta * pzeta - pzeta * pxi
                       + pxi * peta * pzeta;

               }
              }
            }
          }
         }
      }

      return;
#undef ue_1jk
#undef ue_nx0jk
#undef ue_i1k
#undef ue_iny0k
#undef ue_ij1
#undef ue_ijnz
}
