

! locking mechanism used in 1D recv queue benchmark
module queue_lock_module

use, intrinsic :: iso_fortran_env, only: lock_type

  !integer :: npartdom = 4
  integer,parameter :: npartdom = 2
  type(lock_type) :: queue_lock[npartdom,*]

end module queue_lock_module




module destination_comp

contains
!=============================================================================
integer function get_dest2(iteration,zeon_value,first_mod,secnd_mod,third_mod,fourth_mod)
!=============================================================================
  implicit none 
  
  integer,INTENT(IN) :: iteration,zeon_value,first_mod,secnd_mod,third_mod,fourth_mod
  
  get_dest2 = -1
  
  if( iteration <= 4 .AND. mod(zeon_value,first_mod) == 0 ) then
    get_dest2 = 4 - iteration !if mod x==0 then send to 4th right neighbor
  elseif( iteration <= 3 .AND. mod(zeon_value,secnd_mod) == 0 ) then
   get_dest2 = 3 - iteration
  elseif( iteration <= 2 .AND. mod(zeon_value,third_mod) == 0 ) then
    get_dest2 = 2 - iteration
  elseif( iteration <= 1 .AND. mod(zeon_value,fourth_mod) == 0 ) then
    get_dest2 = 1 - iteration        
  endif
  
  return
      
end function get_dest2

! ------------------------------

!=============================================================================
subroutine compute_toroidal_dest(mpi,zeon_1D,CAF_rank,nproc_toroidal,memax,safety_extra_bounds,&
                                 nr_of_possible_send_destinations,send_mask,test,myrank_partd)
!=============================================================================
implicit none 
  
  integer :: mpi,CAF_rank,nproc_toroidal,nr_of_possible_send_destinations,memax,zeon_it,dest
  integer :: safety_extra_bounds, sum_to_the_left, sum_to_the_right, test,myrank_partd
  real(8),dimension(memax) :: zeon_1D
  integer,dimension(1:nr_of_possible_send_destinations) :: send_mask
  integer, allocatable :: send_mask_counter(:)
  
  allocate(send_mask_counter(1:nr_of_possible_send_destinations))
  send_mask_counter = 0
  sum_to_the_left = 0
  sum_to_the_right = 0
  
  dest = -1
  !if(CAF_rank==1) write(*,*) 'ZZ 1 main MPI : zeon_1D=',zeon_1D(1:memax)
  !if(CAF_rank==1) write(*,*) ' '
  
  do zeon_it = 1, memax
    !-------------- to the LEFT --------------
    if( mod(int(zeon_1D(zeon_it) ),send_mask(1)) == 0 ) then
      dest = mod(CAF_rank-1 -5 +nproc_toroidal,nproc_toroidal)+1
      send_mask_counter(1) = send_mask_counter(1) + 1
      !if(CAF_rank==1) write(*,*) 'A zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it) ),send_mask(6)) == 0 ) then
      dest = mod(CAF_rank-1 +5,nproc_toroidal)+1
      send_mask_counter(6) = send_mask_counter(6) + 1
      !if(CAF_rank==1) write(*,*) 'B zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(2)) == 0 ) then
      dest = mod(CAF_rank-1 -4 +nproc_toroidal,nproc_toroidal)+1
      send_mask_counter(2) = send_mask_counter(2) + 1
      !if(CAF_rank==1) write(*,*) 'C zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(7)) == 0 ) then
      dest = mod(CAF_rank-1 +4,nproc_toroidal)+1
      send_mask_counter(7) = send_mask_counter(7) + 1
      !if(CAF_rank==1) write(*,*) 'D zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it) ),send_mask(3)) == 0 ) then
      dest = mod(CAF_rank-1 -3 +nproc_toroidal,nproc_toroidal)+1
      send_mask_counter(3) = send_mask_counter(3) + 1
      !if(CAF_rank==1) write(*,*) 'E zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it) ),send_mask(8)) == 0 ) then
      dest = mod(CAF_rank-1 +3,nproc_toroidal)+1
      send_mask_counter(8) = send_mask_counter(8) + 1
      !if(CAF_rank==1) write(*,*) 'F zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(4)) == 0 ) then
      dest = mod(CAF_rank-1 -2 +nproc_toroidal,nproc_toroidal)+1
      send_mask_counter(4) = send_mask_counter(4) + 1
      !if(CAF_rank==1) write(*,*) 'G zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(9)) == 0 ) then
      dest = mod(CAF_rank-1 +2,nproc_toroidal)+1
      send_mask_counter(9) = send_mask_counter(9) + 1
      !if(CAF_rank==1) write(*,*) 'H zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(5)) == 0 ) then
      dest = mod(CAF_rank-1 -1 +nproc_toroidal,nproc_toroidal)+1
      send_mask_counter(5) = send_mask_counter(5) + 1
      !if(CAF_rank==1) write(*,*) 'I zeon_it=',zeon_it,'dest=',dest
      
    elseif( mod(int(zeon_1D(zeon_it)),send_mask(10)) == 0 ) then
      dest = mod(CAF_rank-1 +1,nproc_toroidal)+1
      send_mask_counter(10) = send_mask_counter(10) + 1
      !if(CAF_rank==1) write(*,*) 'J zeon_it=',zeon_it,'dest=',dest   
      
    endif
    if(mpi==1) dest = dest - 1
    zeon_1D(zeon_it) = dest
    dest = -1
   
  enddo
  !if(CAF_rank==1) write(*,*) 'ZZ 2 main MPI : zeon_1D=',zeon_1D(1:memax)
  
  sum_to_the_left = send_mask_counter(1) + send_mask_counter(2) + send_mask_counter(3) +&
                    send_mask_counter(4) + send_mask_counter(5)
  sum_to_the_right = send_mask_counter(6) + send_mask_counter(7) + send_mask_counter(8) +&
                    send_mask_counter(9) + send_mask_counter(10)
  if(test==1 .AND. CAF_rank==1 .AND. myrank_partd==0 ) then 
    write(*,*) 'Module.F90 : CAF_rank=',CAF_rank,'send_mask_counter=',&
    send_mask_counter,'sum_to_the_left=',sum_to_the_left,'sum_to_the_right=',sum_to_the_right
  endif
  
  deallocate(send_mask_counter)
!=============================================================================
end subroutine compute_toroidal_dest
!=============================================================================





!=============================================================================
  Subroutine set_particle_decomp(mype,numberpe,npartdom,ntoroidal,particle_domain_location,&
                                 toroidal_domain_location,partd_comm,toroidal_comm,&
                                 nproc_partd,myrank_partd,nproc_toroidal,myrank_toroidal,&
                                 left_pe,right_pe,my_global_toroidal_neighbors_CAF)
!=============================================================================

  implicit none
  
  include 'mpif.h'
  
  integer :: i,j,k,pe_number,mtest,ierror,numberpe,mype,toroidal_domain_location, cnt
  integer :: particle_domain_location,partd_comm,toroidal_comm,nproc_partd,myrank_partd
  integer :: nproc_toroidal,myrank_toroidal,left_pe,right_pe,npartdom,ntoroidal
  integer,allocatable :: core_map(:,:)
  integer :: my_global_toroidal_neighbors_CAF(1:ntoroidal-1)

! ----- First we verify the consistency of ntoroidal and npartdom -------
! The number of toroidal domains (ntoroidal) times the number of particle
! "domains" (npartdom) needs to be equal to the number of processor "numberpe".
! numberpe cannot be changed since it is given on the command line.

  if(mype==0)then
    write(0,*)'*******************************************************'
    write(0,*)'  Using npartdom=',npartdom,' and ntoroidal=',ntoroidal
    write(0,*)'*******************************************************'
    write(0,*)
  endif

! We now give each PE (task) a unique domain identified by 2 numbers: the
! particle and toroidal domain numbers.
!    particle_domain_location = rank of the particle domain holding mype
!    toroidal_domain_location = rank of the toroidal domain holding mype
! 
! On the IBM SP, the MPI tasks are distributed in an orderly fashion to each
! node unless the LoadLeveler instruction "#@ blocking = unlimited" is used.
! On Seaborg for example, the first 16 tasks (mype=0-15) will be assigned to
! the first node that has been allocated to the job, then the next 16
! (mype=16-31) will be assigned to the second node, etc. When not using the
! OpenMP, we want the particle domains to sit on the same node because
! communication is more intensive. To achieve this, successive PE numbers are
! assigned to the particle domains first.
! It is easy to achieve this ordering by simply using mype/npartdom for
! the toroidal domain and mod(mype,npartdom) for the particle domain.
!
  
  ! ORIG:
  particle_domain_location=mod(mype,npartdom)
  toroidal_domain_location=mype/npartdom
  
  !particle_domain_location=mype/npartdom
  !toroidal_domain_location=mod(mype,npartdom) 

  !write(0,*)'mype=',mype,"  particle_domain_location =",&
  !           particle_domain_location,' toroidal_domain_location =',&
  !           toroidal_domain_location
 
  allocate(core_map(1:npartdom,1:ntoroidal))
 
  do i=1,npartdom
    do j=1,ntoroidal
      core_map(i,j) = i + (j-1)*npartdom - 1
    enddo
  enddo
  !do i=1,npartdom
  !  write(0,*)'mype=',mype,'core_map(',i,')=',core_map(i,1:ntoroidal)
  !enddo
   
  if(mype==0) then
    open (unit=7, file='MPICH_RANK_ORDER', status='unknown')
    do i=1,npartdom
      write(7,*) core_map(i,1:ntoroidal),','
    enddo
  endif
 
  cnt = 1
  do j=1,ntoroidal
    if( mype .NE. core_map(particle_domain_location+1,j) ) then
      my_global_toroidal_neighbors_CAF(cnt) = core_map(particle_domain_location+1,j)+1
      cnt = cnt + 1
    endif
  enddo
 
  deallocate(core_map)

! ---- Create particle domain communicator and toroidal communicator -----
! We now need to create a new communicator which will include only the
! processes located in the same toroidal domain. The particles inside
! each toroidal domain are divided equally between "npartdom" processes.
! Each one of these processes will do a charge deposition on a copy of
! the same grid, requiring a toroidal-domain-wide reduction after the
! deposition. The new communicator will allow the reduction to be done
! only between those processes located in the same toroidal domain.
!
! We also need to create a purely toroidal communicator so that the
! particles with the same particle domain id can exchange with their
! toroidal neighbors.
!
! Form 2 subcommunicators: one that includes all the processes located in
! the same toroidal domain (partd_comm), and one that includes all the
! processes part of the same particle domain (toroidal_comm).
! Here is how to create a new communicator from an old one by using
! the MPI call "MPI_COMM_SPLIT()".
! All the processes passing the same value of "color" will be placed in
! the same communicator. The "rank_in_new_comm" value will be used to
! set the rank of that process on the communicator.
!  call MPI_COMM_SPLIT(old_comm,color,rank_in_new_comm,new_comm,ierror)

! particle domain communicator (for communications between the particle
! domains WITHIN the same toroidal domain)
  call MPI_COMM_SPLIT(MPI_COMM_WORLD,toroidal_domain_location,&
                      particle_domain_location,partd_comm,ierror)

! toroidal communicator (for communications BETWEEN toroidal domains of same
! particle domain number)
  call MPI_COMM_SPLIT(MPI_COMM_WORLD,particle_domain_location,&
                      toroidal_domain_location,toroidal_comm,ierror)

  call mpi_comm_size(partd_comm,nproc_partd,ierror)
  call mpi_comm_rank(partd_comm,myrank_partd,ierror)

  call mpi_comm_size(toroidal_comm,nproc_toroidal,ierror)
  call mpi_comm_rank(toroidal_comm,myrank_toroidal,ierror)

  if(mype==0) write(0,*)'mype=',mype,'  nproc_toroidal=',nproc_toroidal,&
       ' myrank_toroidal=',myrank_toroidal,'  nproc_partd=',nproc_partd,&
       ' myrank_partd=',myrank_partd

  if(nproc_partd/=npartdom)then
    write(0,*)'*** nproc_partd=',nproc_partd,' NOT EQUAL to npartdom=',npartdom
    call MPI_ABORT(MPI_COMM_WORLD,1,ierror)
  endif

  if(nproc_toroidal/=ntoroidal)then
    write(0,*)'*** nproc_toroidal=',nproc_toroidal,' NOT EQUAL to ntoroidal=',&
              ntoroidal
    call MPI_ABORT(MPI_COMM_WORLD,1,ierror)
  endif

! We now find the toroidal neighbors of the current toroidal domain and
! store that information in 2 easily accessible variables. This information
! is needed several times inside the code, such as when particles cross
! the domain boundaries. We will use the toroidal communicator to do these
! transfers so we don't need to worry about the value of myrank_partd.
! We have periodic boundary conditions in the toroidal direction so the
! neighbor to the left of myrank_toroidal=0 is (ntoroidal-1).

  left_pe=mod(myrank_toroidal-1+ntoroidal,ntoroidal)
  right_pe=mod(myrank_toroidal+1,ntoroidal)

end subroutine set_particle_decomp


end module destination_comp




module array_of_PointerToMatrix_module

   TYPE :: ptr_to_matrix
     REAL(8), DIMENSION(:,:), POINTER :: matrix
   END TYPE ptr_to_matrix
   
   TYPE :: array_ptr_to_matrix
     type(ptr_to_matrix), DIMENSION(:),POINTER :: array_of_matrix
   END TYPE array_ptr_to_matrix

end module array_of_PointerToMatrix_module



!module array_of_PointerToCoArray_module
!
!   TYPE :: ptr_to_CoArray
!     REAL(8), DIMENSION(:), POINTER :: CoArray[:]
!   END TYPE ptr_to_CoArray
!
!end module array_of_PointerToCoArray_module


