#include <stdio.h>
#include <stdlib.h>
//
// A(i,j) is addressed as a[i].row[j]
//
typedef struct {
  float *row;
  size_t row_size;
} Tri_matrix;

int main(void) {
  size_t n, i_row;
  size_t i, j;
  Tri_matrix *A;

  scanf("%li %li",&n,&i_row);

  A = (Tri_matrix *) malloc(n*sizeof(Tri_matrix));
//
// create triangular matrix
  for (i=0; i<n; i++) {
    A[i].row_size = n - i;
    A[i].row = (float *) malloc(A[i].row_size*sizeof(float));
  }
//
// initialize matrix A(i, j) = i + j
  for (i=0; i<n; i++) {
    for (j=0; j<n-i; j++) {
      A[i].row[j] = (float) (i + 1) + (float) (j + 1);
    }
  }
//
// write row number i_row to standard output
  printf(" Row %li:\n", i_row);
  if (i_row <= n) {
    for (j=0; j<n-i_row+1; j++) {
      printf("%12.1f\n", A[i_row-1].row[j]);
    }
  }
//
// clean up
  for (i=0; i<n; i++) {
    free(A[i].row);
  }
  free(A);
}
